#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "Professor.h"

class Course {

   private:
      char *code;
      char *title;
      int credits;
      Professor *prof;

   public:
      Course(const char *pcode, const char *ptitle, int pcredits, const char *pname) {
	  // new aloca dinamicanente um arranjo de chars
 	  code = new char[strlen(pcode)+1];
	  strcpy(code, pcode);
	  title = new char[strlen(ptitle)+1];
	  strcpy(title, ptitle);
 	  
	  credits = pcredits;
	  
	  // no caso do professor nao alocamos diretamente, mas
	  // o 'new' ira chamar o construtor de professor para fazer isso
 	  prof = new Professor(pname);
	  
	  printf("Construtor > Course\n");
      }
      
      ~Course() {
	  // code e title sao arranjos e portanto colocamos
	  // os colchetes para que o delete faça a limpeza de todo
	  // o arranjo
	  delete[] code;
	  delete[] title;
	  
	  // para o objeto prof, apenas usamos delete, que ira
	  // chamar o destrutor de Professor
	  delete prof;	
	  
	  code = NULL;
	  title = NULL;
	  prof = NULL;
	  credits = 0;
	  printf("Destrutor > Course\n");
      }
      
      void printCourse() {
	  printf("\n%s, %s, Credits: %d, Professor: %s\n",
		 code, title, credits, prof->getName());
      }
};